//+------------------------------------------------------------------+
//| RWI.mq5                                                          |
//|    (Random Walk Index)                   |
//| From MetaStock Indicator: Random Walk Index by E. Michael Poulos |
//| Ramdass                                                          |
//+------------------------------------------------------------------+
//  Random Walk Index ,  ,                |
//                              |
//       .               |
//      ,           |
//     .                |
//        RWI                   |
//    .            |
//    RW    . |
//     ,  RWI  >1,        |
//           RWI >1. |
//                                                                   |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, Ramdass"
#property  link      ""
//---   
#property version   "1.00"
//---     
#property indicator_separate_window 
//---    2
#property indicator_buffers 2 
//---    
#property indicator_plots   1
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//---      
#property indicator_type1   DRAW_FILLING
//---     
#property indicator_color1  clrDodgerBlue,clrDeepPink
//---   
#property indicator_label1  "RWI"
//+----------------------------------------------+
//|   CXMA                         |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA XMA1,XMA2;
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint RWI_Period=25;                        //   RWI
input Smooth_Method XMA_Method=MODE_JJMA;        //  
input uint XPeriod=5;                            //  
input int XPhase=15;                             //  
//+----------------------------------------------+
//---   ,   
//---      
double ExtABuffer[],ExtBBuffer[];
//---       
int Ind_Handle;
//---      
int  min_rates_1,min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---     
   min_rates_1=int(RWI_Period)+1;
   min_rates_total=min_rates_1+XMA1.GetStartBars(XMA_Method,XPeriod,XPhase);
//---    iATR
   Ind_Handle=iATR(Symbol(),PERIOD_CURRENT,RWI_Period);
   if(Ind_Handle==INVALID_HANDLE)
     {
      Print("      iATR");
      return(INIT_FAILED);
     }
//---      
   SetIndexBuffer(0,ExtABuffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(ExtABuffer,true);
//---      
   SetIndexBuffer(1,ExtBBuffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(ExtBBuffer,true);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"RWI");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+  
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total || BarsCalculated(Ind_Handle)<rates_total) return(RESET);
//---    
   int to_copy,limit,bar,maxbar;
//---       
   double iInd[],max_High,max_Low,res,max_1,max_2;
//---         
   ArraySetAsSeries(iInd,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
//---     
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_1-1; //      
     }
   else limit=rates_total-prev_calculated; //      
//---   
   to_copy=limit+1+int(RWI_Period);
//---      
   if(CopyBuffer(Ind_Handle,0,0,to_copy,iInd)<=0) return(RESET);
//---
   maxbar=rates_total-min_rates_1-1;
//---    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      max_High=0.0;
      max_Low=0.0;
      for(int kkk=0; kkk<int(RWI_Period); kkk++)
        {
         res=MathSqrt(kkk+1)*iInd[bar+kkk];
         if(res)
           {
            max_1=(high[bar]-low[bar+kkk])/res;   // RWI_High Index
            max_2=(high[bar+kkk]-low[bar])/res;   // RWI_Low Index
            if(max_1>max_High) max_High = max_1;  // Maximum_RWI_High Index
            if(max_2>max_Low) max_Low = max_2;    // Maximum_RWI_Low Index
           }
        }
      ExtABuffer[bar]=XMA1.XMASeries(maxbar,prev_calculated,rates_total,XMA_Method,XPhase,XPeriod,max_High,bar,true);
      ExtBBuffer[bar]=XMA2.XMASeries(maxbar,prev_calculated,rates_total,XMA_Method,XPhase,XPeriod,max_Low,bar,true);
     }
//---    
   return(rates_total);
  }
//+------------------------------------------------------------------+
